<h1>Testes unitários em Java utilizando JUnit</h1>

<p>Este curso tem como objetivo habilitar o(a) aluno(a) a testar soluções desenvolvidas na linguagem Java, tornando-o apto a apoiar a implantação e utilização da Plataforma Digital do Poder Judiciário – PDPJ-Br no seu Tribunal.</p>
<p>Ao final do curso o participante deverá demonstrar ampla capacidade no uso dos conceitos de testes em Java conhecendo, entre outros:
<strong>Criação de testes unitários em Java utilizando JUnit.</strong>
</p>

<h2>Por que testamos?</h2>
<ul>
<li>
Os testes automatizados vêm como uma forma de poupar tempo de detecção de erros e de aumento de confiabilidade com relação aos testes em si.
</li>
<li>
O software deve fazer o que o cliente precisa de maneira confiável, segura, eficiente e flexível. 
</li>
<li>
Para um software ser testado corretamente, esse processo deve ser automatizado com o auxílio de ferramentas com esta finalidade.
</li>
</ul>

<h2>Alguns tipos de Testes:</h2>
<ul>
<strong>
<li>Testes Unitários</li>
<li>Testes de Integração</li>
<li>Testes de Aceitação</li>
<li>Testes de Carga ou Desempenho</li>
</strong>
<li>Teste Funcional</li>
<li>Teste Exploratório</li>
<li>Teste de Segurança</li>
<li>Teste de Performance</li>
<li>Teste de Usabilidade</li>
</ul>

<h2>Testes Unitários</h2>
<li>
Podemos definir como Teste Unitário, o teste da menor parte testável de um software.
</li>
<li>
O objetivo principal dos testes automatizados é de garantir que uma aplicação continue funcionando mesmo após mudanças no código-fonte.
</li>
<li>
Testes Unitários não dependem de nenhum processo ou sistema externo (banco de dados, console, rede e etc.)
</li>

<h2> JUnit </h2>
<ul>
<li>
JUnit é um framework open-source que possibilita a criação de testes unitários em Java.
</li>
<li>
Este framework tem como objetivo, facilitar a criação de casos de teste, além de permitir escrever testes que retenham seu valor ao longo do tempo, ou seja, que possam ser reutilizáveis.
</li>
<li>
Algumas IDEs para desenvolvimento Java já incorpora o JUnit.
</li>
</ul>

<h2>F.I.R.S.T</h2>
<ul>
<li>
<strong>F</strong>ast: Os testes devem executar com rapidez. 
</li>
<li>
<strong>I</strong>ndependent: Os testes não devem depender um dos outros.
</li>
<li>
<strong>R</strong>epeatable: Deve-se poder repetir os testes em qualquer ambiente.
</li>
<li>
<strong>S</strong>elf-Validating: Os testes devem ter uma saída booleana.
</li>
<li>
<strong>T</strong>imely: Os testes precisam ser escritos em tempo hábil.
</li>
</ul>

<h2>TDD</h2>
<ol>
<li>
É escrito um teste que irá falhar e qualquer forma.
</li>
<li>
Em seguida, desenvolve-se a função que deverá fazer o teste passar e então reaplicá-lo.
</li>
<li>
Feito os dois passos anteriores é importante refatorar o código a fim de evitar redundância. 
</li>
</ol>

<h2>Referências</h2>

<ul>
<li>https://www.treinaweb.com.br/cursos/java-testes-unitarios-com-junit-5</li>
<li>https://www.techlise.com.br/blog/tudo-o-que-voce-precisa-saber-sobre-tdd/</li>
<li>https://dayvsonlima.medium.com/entenda-de-uma-vez-por-todas-o-que-s%C3%A3o-testes-unit%C3%A1rios-para-que-servem-e-como-faz%C3%AA-los-2a6f645bab3</li>
<li>http://www.linhadecodigo.com.br/artigo/576/java-testes-unitarios-e-junit.aspx#ixzz7Epz46Qen</li>
<li>https://www.treinaweb.com.br/blog/afinal-o-que-e-tdd</li>
<li>https://medium.com/editora-globo/testes-parametrizados-com-junit-5-3ba8d3956d55</li>
<li>https://medium.com/@luksrn/testes-parametrizados-no-junit-5-bace7c1087ef</li>
<li>https://www.baeldung.com/junit-assertions</li>
<li>https://javabydeveloper.com/junit-5-assumptions-examples/</li>
<li>https://www.codingeek.com/tutorials/junit/junit-displayname-and-custom-display-name-generator/</li>
<li>https://www.codingeek.com/tutorials/junit/junit-assumptions-examples/</li>
</ul>

------------

Disponibilizado com ♥ por [cami-la](https://www.linkedin.com/in/cami-la/ "cami-la").








